
const scriptName = '转转搜索';
const magicJS = MagicJS(scriptName, "INFO");


async function Main() {
    if (magicJS.isRequest) {
    } else {
        updateHeaders();
        await trySearch();
    }
    magicJS.notification.msg('');
    magicJS.done();
}

function updateHeaders() {
}


async function trySearch() {
    let total = 1;
    for (let i = 1; i <= total; i++) {
        magicJS.logger.info(`[0]搜索进度${i}/${total}`);
        let retSearch = await doSearch("iphone 15 pro", i);
        if (retSearch.respCode != '0') {
            continue;
        }
        let respData = retSearch.respData;
        magicJS.logger.info(`[1]搜索进度${i}/${total}`);
        let infos = respData.infos;
        magicJS.logger.info(`[2]搜索结果数：${infos.length}`);
        for (let info of infos) {
            magicJS.logger.info(`infoId=${info.infoId}`);
            if (info.infoId == void 0) {
                continue;
            }
            let retGoodsInfo = await getGoodsInfo(info.infoId);
            let report = retGoodsInfo.respData?.report;
            // magicJS.logger.info(`rsreportpData=${JSON.stringify(report)}`);
            let itemId2AttrInfo = report.itemId2AttrInfo;
            // magicJS.logger.info(`itemId2AttrInfo=${JSON.stringify(itemId2AttrInfo)}`);
            if (itemId2AttrInfo && checkOSVersionLow(itemId2AttrInfo, '17.0')) {
                magicJS.logger.info(`匹配到${JSON.stringify(itemId2AttrInfo)}`);
                await addLoveInfo(info.infoId);
            }
            await magicJS.utils.sleep(1000);
        }
        await magicJS.utils.sleep(1000);
    }
}

function checkOSVersionLow(reportData, osVersion) {
    let itemId2AttrInfo = reportData.itemId2AttrInfo;
    for (let k in itemId2AttrInfo) {
        const itemeAttrInfo = itemId2AttrInfo[k];
        if (itemeAttrInfo.itemName == '系统版本' && itemeAttrInfo.content != void 0) {
            magicJS.logger.info(`系统版本：${itemeAttrInfo.content}`);
            if (compareVersions(osVersion, itemeAttrInfo.content) == -1) {
                return true;
            }
        }
    }
    return false;
}

function compareVersions(version1, version2) {
    const v1 = version1.split('.').map(Number);
    const v2 = version2.split('.').map(Number);

    for (let i = 0; i < Math.max(v1.length, v2.length); i++) {
        const num1 = i < v1.length ? v1[i] : 0;
        const num2 = i < v2.length ? v2[i] : 0;

        if (num1 < num2) {
            return -1;
        } else if (num1 > num2) {
            return 1;
        }
    }
    return 0;
}

async function doSearch(keyword, pagenum = 1, pagesize = 20) {
    const url = `https://app.zhuanzhuan.com/zz/transfer/search`;
    const headers = {
        'zzReqT': `1736142162000`,
        'Csrf-Token': `12921dc6df40d814575bb84e16f2ac148129ceed`,
        'Accept-Encoding': `gzip,deflate`,
        'zzreferer': `https://app.zhuanzhuan.com/zz/16/E1007`,
        'Connection': `keep-alive`,
        'X-ZZ-Monitoring-Metrics': `feMetricAntiCheatLevel=V1`,
        'Content-Type': `application/x-www-form-urlencoded`,
        'zztk': ``,
        'zzReqSign': `2816d141f43575910e66212e51194563`,
        'zzht': `i_16`,
        'User-Agent': `zhuanzhuan/11.6.0 (iPhone; iOS 18.2; Scale/3.00)`,
        'Cookie': `dualTrackFinenessAbRaw=A;platformUpgradeRaw=9311;tk=70c64fd1ab35b08360a02901c03abb4758a15705;platformUpgradeLuxin=3;PPU="TT=12921dc6df40d814575bb84e16f2ac148129ceed&UID=100535294213798016&CT=1736141595202&SF=ZHUANZHUAN&SCT=1736145195202&V=2&ET=1738733595202&AP=16"; Version=1; Domain=zhuanzhuan.com; Max-Age=2592000; Expires=Wed, 05-Feb-2025 05:33:15 GMT;;brandUpgradeAB=0;lon=0.000000;brand=Apple;t=16;sts=1736141595142;platformUpgradeYumi=1;feedRecommendation=0;v=11.6.0;dualTrackFinenessAbSwitch=0;officialVerifyUnifyAB=C;zz_t=16;uid=100535294213798016;Safe-PPU="TT=12921dc6df40d814575bb84e16f2ac148129ceed&UID=100535294213798016&CT=1736141595202&SF=ZHUANZHUAN&SCT=1736145195202&V=2&ET=1738733595202&AP=16"; Version=1; Domain=zhuanzhuan.com; Max-Age=2592000; Expires=Wed, 05-Feb-2025 05:33:15 GMT;;request_remove_latlon=0;model=iPhone15%2C2;lat=0.000000;platformUpgradeSwitch=1;`,
        'Host': `app.zhuanzhuan.com`,
        'zzReqAllParam': `sessionStr|searcfilterhmove2zzsearch|searchStandardPropertiesAB|searchPageSource|keyword|usePgParam|pagesize|zzReqT|serviceId|verticalAbTest|requestmark|pageIdParams|pagenum|searchsuggestcate|pushcode|searchRecommendRankAB|filterModuleServerParamsInput|search_9_0_0|zztk|v7abtest|changeIntention|recModelAB|searchfrom|searchAccurateFilterAB|b2cInfoCardAB`,
        'Referer': `https://app.zhuanzhuan.com/zz/16/E1007`,
        'Accept-Language': `zh-Hans-CN;q=1`,
        'Accept': `*/*`
    };
    let filterModuleServerParamsInput = {
        "searchScene": 1,
        "scene": 1,
        "filterModuleParam": {
            "version": "1.7.0",
            "appType": "2"
        },
        "keyword": keyword
    };
    let pageIdParams = {
        "refpagequery": "from=1",
        "refpagetype": "V1008",
        "refsubpageid": ""
    };
    let sessionData = {
        "abtest": "feedwords.base_feedwords_0407_base:flow_management_362.cgroup_flow_management_362:flow_management_405.agroup_flow_management_405:flow_management_407.agroup_flow_management_407:segment.base_segment_0412_base:sortstrategy.base_sortstrategy_0407_base:termrecalloff.termrecalloff0102",
        "session": "70c64fd1ab35b08360a02901c03abb4758a15705"
    };
    let postData = {
        "b2cInfoCardAB": "B",
        "changeIntention": "0",
        "filterModuleServerParamsInput": (JSON.stringify(filterModuleServerParamsInput)),
        "keyword": keyword,
        "pageIdParams": (JSON.stringify(pageIdParams)),
        "pagenum": String(pagenum),
        "pagesize": String(pagesize),
        "pushcode": "1",
        "recModelAB": "1",
        "requestmark": "1736142162130",
        "searcfilterhmove2zzsearch": "1",
        "searchAccurateFilterAB": "2",
        "searchPageSource": "1",
        "searchRecommendRankAB": "A",
        "searchStandardPropertiesAB": "B",
        "search_9_0_0": "B",
        "searchfrom": "1",
        "searchsuggestcate": "1",
        "serviceId": "",
        "sessionStr": (JSON.stringify(sessionData)),
        "usePgParam": "1",
        "v7abtest": "1",
        "verticalAbTest": ""
    }
    let bodyText = magicJS.objToQueryStr(postData, true);
    // magicJS.logger.info(`bodyText=${bodyText}`);
    bodyText = `b2cInfoCardAB=B&changeIntention=0&filterModuleServerParamsInput=%7B%22searchScene%22%3A1%2C%22scene%22%3A1%2C%22filterModuleParam%22%3A%7B%22version%22%3A%221.7.0%22%2C%22appType%22%3A%222%22%7D%2C%22keyword%22%3A%22iphone%2015%20pro%22%7D&keyword=iphone%2015%20pro&pageIdParams=%7B%22refpagequery%22%3A%22from%3D1%22%2C%22refpagetype%22%3A%22V1008%22%2C%22refsubpageid%22%3A%22%22%7D&pagenum=1&pagesize=20&pushcode=1&recModelAB=1&requestmark=1736142162130&searcfilterhmove2zzsearch=1&searchAccurateFilterAB=2&searchPageSource=1&searchRecommendRankAB=A&searchStandardPropertiesAB=B&search_9_0_0=B&searchfrom=1&searchsuggestcate=1&serviceId=&sessionStr=%7B%22abtest%22%3A%22feedwords.base_feedwords_0407_base%3Aflow_management_362.cgroup_flow_management_362%3Aflow_management_405.agroup_flow_management_405%3Aflow_management_407.agroup_flow_management_407%3Asegment.base_segment_0412_base%3Asortstrategy.base_sortstrategy_0407_base%3Atermrecalloff.termrecalloff0102%22%2C%22session%22%3A%2270c64fd1ab35b08360a02901c03abb4758a15705%22%7D&usePgParam=1&v7abtest=1&verticalAbTest=`;

    bodyText = `b2cInfoCardAB=B&changeIntention=0&filterModuleServerParamsInput=%7B%22searchScene%22%3A1%2C%22scene%22%3A1%2C%22filterModuleParam%22%3A%7B%22version%22%3A%221.7.0%22%2C%22appType%22%3A%222%22%7D%2C%22keyword%22%3A%22iphone15%22%7D&keyword=iphone15&pageIdParams=%7B%22refpagequery%22%3A%22from%3D14%22%2C%22refpagetype%22%3A%22V1008%22%2C%22refsubpageid%22%3A%22%22%7D&pagenum=1&pagesize=20&pushcode=1071&recModelAB=1&requestmark=1736155352263&searcfilterhmove2zzsearch=1&searchAccurateFilterAB=2&searchRecommendRankAB=A&searchStandardPropertiesAB=B&search_9_0_0=B&searchfrom=1071&searchsuggestcate=1&serviceId=&sessionStr=%7B%22abtest%22%3A%22feedwords.base_feedwords_0407_base%3Aflow_management_362.cgroup_flow_management_362%3Aflow_management_405.agroup_flow_management_405%3Aflow_management_407.agroup_flow_management_407%3Asegment.base_segment_0412_base%3Asortstrategy.base_sortstrategy_0407_base%3Atermrecalloff.termrecalloff0102%22%2C%22session%22%3A%2270c64fd1ab35b08360a02901c03abb4758a15705%22%7D&usePgParam=1&v7abtest=1&verticalAbTest=`
    bodyText = bodyText.replace('requestmark=1736155352263', `requestmark=${Date.now()}`);
    bodyText = bodyText.replace('pagenum=1&pagesize=20', `pagenum=${pagenum}&pagesize=${pagesize}`);
    let options = {
        url: url,
        headers: headers,
        body: bodyText,
    };
    let result = await magicJS.http.post(options).then(response => {
        try {
            let rspData = response.body;
            // magicJS.logger.info(`rspData=${JSON.stringify(rspData)}`);
            return rspData;
        } catch (e) {
            magicJS.logger.error(e);
        }
    }).catch(err => {
        const msg = `请求搜索结果\n${JSON.stringify(err)}`;
        magicJS.logger.error(msg);
    });
    return result;
}

async function getGoodsInfo(infoId) {
    const url = `https://app.zhuanzhuan.com/zzopen/waresshow/moreInfo?previewToken=&infoId=${infoId}&platform=&requestType=1&packageId=&version=&t=&ip=&uid=&orderId=&searchFrom=&quickStart=1`;
    const headers = {
        'Sec-Fetch-Dest': `empty`,
        'Connection': `keep-alive`,
        'Accept-Encoding': `gzip, deflate, br`,
        'X-ZZ-Monitoring-Metrics': `feMetricAntiCheatLevel=V1`,
        'Content-Type': `application/x-www-form-urlencoded; charset=utf-8`,
        'Sec-Fetch-Site': `same-site`,
        'Origin': `https://m.zhuanzhuan.com`,
        'User-Agent': `Mozilla/5.0 (iPhone; CPU iPhone OS 18_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 zzVersion/11.6.0 zzT/16 zzDevice/1_177.0_3.0 zzApp/58ZhuanZhuan`,
        'Sec-Fetch-Mode': `cors`,
        'Cookie': `PPU="TT=12921dc6df40d814575bb84e16f2ac148129ceed&UID=100535294213798016&CT=1736141595202&SF=ZHUANZHUAN&SCT=1736145195202&V=2&ET=1738733595202&AP=16"; Version=1; Domain=zhuanzhuan.com; Max-Age=2592000; Expires=Wed, 05-Feb-2025 05:33:15 GMT;; Safe-PPU="TT=12921dc6df40d814575bb84e16f2ac148129ceed&UID=100535294213798016&CT=1736141595202&SF=ZHUANZHUAN&SCT=1736145195202&V=2&ET=1738733595202&AP=16"; Version=1; Domain=zhuanzhuan.com; Max-Age=2592000; Expires=Wed, 05-Feb-2025 05:33:15 GMT;; app-apn=WIFI; app-clientip=fe80::1cd7:a4c7:5096:c1c4; app-os=iOS; app-osv=18.2; app-resolution=1179x2556; brand=Apple; brandUpgradeAB=0; dualTrackFinenessAbRaw=A; dualTrackFinenessAbSwitch=0; feedRecommendation=0; isoffline=0; lat=0.000000; lon=0.000000; model=iPhone15%2C2; officialVerifyUnifyAB=C; platformUpgradeLuxin=3; platformUpgradeRaw=9311; platformUpgradeSwitch=1; platformUpgradeYumi=1; referrerObj=%7B%22refpagetype%22%3A%22T2974%22%2C%22refpagequery%22%3A%22infoId%3D1839626049122570757%26metric%3Dpd4CYYZRXk2HvoZsXpfvhw1106xdb%26needHideShare%3D1%26quickStart%3D1%22%2C%22refsubpageID%22%3A%22%22%2C%22refsectionId%22%3A%22%22%2C%22refsortId%22%3A%22%22%7D; request_remove_latlon=0; t=16; tk=70c64fd1ab35b08360a02901c03abb4758a15705; uid=100535294213798016; v=11.6.0; zzVisitStack=%5B%7B%22type%22%3A%22onShow%22%2C%22href%22%3A%22m.zhuanzhuan.com%2Ftrade%2Forder_detail_v3%2Findex.html%23%2F%22%2C%22time%22%3A1736141851367%7D%2C%7B%22type%22%3A%22onShow%22%2C%22href%22%3A%22m.zhuanzhuan.com%252Ftrade%252Fshopping-car%252Findex.html%2523%252Fhome%22%2C%22time%22%3A1736142167163%7D%5D; zz_t=16; zzreferer=https%3A%2F%2Fm.zhuanzhuan.com%2Fu%2Fstreamline_detail%2Fnew-goods-detail; id58=CigARGd7bVMqXoOFBOr5Ag==; channel=; fromChannel=; ZZ_SHOP_CHANNEL_ID=2001; h5checkin_channel=h5plpages_homepage; Domain=58.com; Expires=Wed,05-Feb-2025 05:33:15 GMT; Max-Age=2592000; Path=/; Version=1; from=null; goods-token="20b01d67e7b09ead15b4a893463c1d26,d/Vl7HsrTPA4P5pwLF7gH4j+kfSaflrVETVCVKCuih3HvmET9duj6Sw1RJCPtvO1amY8H4DaSWb6ks+PIGkPlQ=="; idzz=CigACGd1iaBIH0BpIbHdAg==; refsectionId=115; refsortId=0; zlj_group_id=13`,
        'Referer': `https://m.zhuanzhuan.com/`,
        'Host': `app.zhuanzhuan.com`,
        'Accept-Language': `zh-CN,zh-Hans;q=0.9`,
        'Accept': `application/json, text/plain, */*`
    };
    let options = {
        url: url,
        headers: headers,
        body: ``,
    };
    let result = await magicJS.http.get(options).then(response => {
        try {
            let rspData = response.body;
            // magicJS.logger.info(`rspData=${JSON.stringify(rspData)}`);
            return rspData;
        } catch (e) {
            magicJS.logger.error(e);
        }
    }).catch(err => {
        const msg = `请求产品详情\n${JSON.stringify(err)}`;
        magicJS.logger.error(msg);
    });
    return result;
}


async function addLoveInfo(infoId) {
    const url = `https://app.zhuanzhuan.com/zz/transfer/addLoveInfo?infoId=${infoId}&metric=DpllOmhehpziKt7xRux3zA1106xdb`;
    const headers = {
        'Sec-Fetch-Dest': `empty`,
        'Csrf-Token': `3af5f53cd4c8962bc4e2405085f42b62b40c0a0b`,
        'Connection': `keep-alive`,
        'Accept-Encoding': `gzip, deflate, br`,
        'Content-Type': `application/x-www-form-urlencoded; charset=utf-8`,
        'Sec-Fetch-Site': `same-site`,
        'Origin': `https://m.zhuanzhuan.com`,
        'User-Agent': `Mozilla/5.0 (iPhone; CPU iPhone OS 18_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 zzVersion/11.6.0 zzT/16 zzDevice/1_177.0_3.0 zzApp/58ZhuanZhuan`,
        'Sec-Fetch-Mode': `cors`,
        'Cookie': `refsectionId=115; refsortId=0; PPU="TT=3af5f53cd4c8962bc4e2405085f42b62b40c0a0b&UID=100535294213798016&CT=1736152170816&SF=ZHUANZHUAN&SCT=1736155770816&V=2&ET=1738744170816&AP=16"; Version=1; Domain=zhuanzhuan.com; Max-Age=2592000; Expires=Wed, 05-Feb-2025 08:29:30 GMT;; Safe-PPU="TT=3af5f53cd4c8962bc4e2405085f42b62b40c0a0b&UID=100535294213798016&CT=1736152170816&SF=ZHUANZHUAN&SCT=1736155770816&V=2&ET=1738744170816&AP=16"; Version=1; Domain=zhuanzhuan.com; Max-Age=2592000; Expires=Wed, 05-Feb-2025 08:29:30 GMT;; app-apn=WIFI; app-clientip=fe80::1cd7:a4c7:5096:c1c4; app-os=iOS; app-osv=18.2; app-resolution=1179x2556; brand=Apple; brandUpgradeAB=0; dualTrackFinenessAbRaw=A; dualTrackFinenessAbSwitch=0; feedRecommendation=0; isoffline=0; lat=0.000000; lon=0.000000; model=iPhone15%2C2; officialVerifyUnifyAB=C; platformUpgradeLuxin=3; platformUpgradeRaw=9311; platformUpgradeSwitch=1; platformUpgradeYumi=1; referrerObj=%7B%22refpagetype%22%3A%22T2974%22%2C%22refpagequery%22%3A%22infoId%3D1839648694882898946%26metric%3DDpllOmhehpziKt7xRux3zA1106xdb%26needHideShare%3D1%26quickStart%3D1%22%2C%22refsubpageID%22%3A%22%22%2C%22refsectionId%22%3A%22%22%2C%22refsortId%22%3A%22%22%7D; request_remove_latlon=0; t=16; tk=70c64fd1ab35b08360a02901c03abb4758a15705; uid=100535294213798016; v=11.6.0; zzVisitStack=%5B%7B%22type%22%3A%22onShow%22%2C%22href%22%3A%22m.zhuanzhuan.com%2Fu%2Fstreamline_detail%2Fnew-goods-detail%22%2C%22time%22%3A1736152201721%7D%2C%7B%22type%22%3A%22onShow%22%2C%22href%22%3A%22m.zhuanzhuan.com%252Fu%252Fstreamline_detail%252Fnew-goods-detail%22%2C%22time%22%3A1736152520638%7D%5D; zz_t=16; zzreferer=https%3A%2F%2Fm.zhuanzhuan.com%2Fu%2Fstreamline_detail%2Fnew-goods-detail; id58=CigAG2d7lceiBT8yB/ezAg==; ZZ_SHOP_CHANNEL_ID=2001; channel=; fromChannel=; h5checkin_channel=h5plpages_homepage; Domain=58.com; Expires=Wed,05-Feb-2025 05:33:15 GMT; Max-Age=2592000; Path=/; Version=1; from=null; goods-token="20b01d67e7b09ead15b4a893463c1d26,d/Vl7HsrTPA4P5pwLF7gH4j+kfSaflrVETVCVKCuih3HvmET9duj6Sw1RJCPtvO1amY8H4DaSWb6ks+PIGkPlQ=="; idzz=CigACGd1iaBIH0BpIbHdAg==; zlj_group_id=13`,
        'Host': `app.zhuanzhuan.com`,
        'Referer': `https://m.zhuanzhuan.com/`,
        'Accept-Language': `zh-CN,zh-Hans;q=0.9`,
        'Accept': `application/json, text/plain, */*`
    };
    let options = {
        url: url,
        headers: headers,
        body: ``,
    };
    let result = await magicJS.http.get(options).then(response => {
        try {
            let rspData = response.body;
            // magicJS.logger.info(`rspData=${JSON.stringify(rspData)}`);
            return rspData;
        } catch (e) {
            magicJS.logger.error(e);
        }
    }).catch(err => {
        const msg = `请求收藏\n${JSON.stringify(err)}`;
        magicJS.logger.error(msg);
    });
    return result;
}

Main().catch((e) => magicJS.logger.log(`-\n ${e}`)).finally(() => magicJS.done());

//---SyncByPyScript---MagicJS3-start
function MagicJS(e = "MagicJS", t = "INFO") { const n = () => { const e = "undefined" != typeof $loon, t = "undefined" != typeof $task, r = "undefined" != typeof module, n = "undefined" != typeof $httpClient && !e, o = "undefined" != typeof $storm, i = "undefined" != typeof $environment && void 0 !== $environment["stash-build"]; var s = n || e || o || i; const a = "undefined" != typeof importModule; return { isLoon: e, isQuanX: t, isNode: r, isSurge: n, isStorm: o, isStash: i, isSurgeLike: s, isScriptable: a, get name() { return e ? "Loon" : t ? "QuantumultX" : r ? "NodeJS" : n ? "Surge" : a ? "Scriptable" : "unknown" }, get build() { return n ? $environment["surge-build"] : i ? $environment["stash-build"] : o ? $storm.buildVersion : void 0 }, get language() { if (n || i) return $environment.language }, get version() { return n ? $environment["surge-version"] : i ? $environment["stash-version"] : o ? $storm.appVersion : r ? process.version : void 0 }, get system() { return n ? $environment.system : r ? process.platform : void 0 }, get systemVersion() { if (o) return $storm.systemVersion }, get deviceName() { if (o) return $storm.deviceName } } }, o = (r, e = "INFO") => { let n = e, t = "\n"; const o = { SNIFFER: 6, DEBUG: 5, INFO: 4, NOTIFY: 3, WARNING: 2, ERROR: 1, CRITICAL: 0, NONE: -1 }, i = { SNIFFER: "", DEBUG: "", INFO: "", NOTIFY: "", WARNING: "❗ ", ERROR: "❌ ", CRITICAL: "❌ ", NONE: "" }, s = (e, t = "INFO") => { o[n] < o[t.toUpperCase()] || console.log(`██[${r}][${t}]` + i[t.toUpperCase()] + e + "\n") }; return { getLevel: () => n, setLevel: e => { n = e }, sniffer: (...e) => { e = e.join(t); s(e, "SNIFFER") }, log: (...e) => { e = e.join(t); console.log(`██[${r}]` + e + "\n") }, debug: (...e) => { e = e.join(t); s(e, "DEBUG") }, info: (...e) => { e = e.join(t); s(e, "INFO") }, notify: (...e) => { e = e.join(t); s(e, "NOTIFY") }, warning: (...e) => { e = e.join(t); s(e, "WARNING") }, error: (...e) => { e = e.join(t); s(e, "ERROR") }, retry: (...e) => { e = e.join(t); s(e, "RETRY") } } }; return new class { constructor(e, t) { var r; this._startTime = Date.now(), this.version = "3.0.0", this.scriptName = e, this.env = n(), this.logger = o(e, t), this.http = "function" == typeof MagicHttp ? MagicHttp(this.env, this.logger) : void 0, this.data = "function" == typeof MagicData ? MagicData(this.env, this.logger) : void 0, this.notification = "function" == typeof MagicNotification ? MagicNotification(this.scriptName, this.env, this.logger, this.http) : void 0, this.utils = "function" == typeof MagicUtils ? MagicUtils(this.env, this.logger) : void 0, this.qinglong = "function" == typeof MagicQingLong ? MagicQingLong(this.env, this.data, this.logger) : void 0, void 0 !== this.data && (t = this.data.read("magic_loglevel"), r = this.data.read("magic_bark_url"), t && this.logger.setLevel(t.toUpperCase()), r) && this.notification.setBark(r), this.logger.info(e + ", 开始执行!") } get isRequest() { return "undefined" != typeof $request } get isStrictRequest() { return "undefined" != typeof $request && "undefined" == typeof $response } get isResponse() { return "undefined" != typeof $response } get isDebug() { return "DEBUG" === this.logger.level } get request() { return "undefined" != typeof $request ? $request : void 0 } get response() { if ("undefined" != typeof $response) return $response.hasOwnProperty("status") && ($response.statusCode = $response.status), $response.hasOwnProperty("statusCode") && ($response.status = $response.statusCode), $response } log(...e) { this.logger.log(e) } toStr(e, t = null) { try { return JSON.stringify(e) } catch { return t } } toObj(e, t = null) { try { return JSON.parse(e) } catch { return t } } checkRecordRequestBody() { if (this.isRequest) { var t = $request.body; if (t) { var r = this.env, n = $request.path; let e = this.scriptName + "#" + n.replace("/", "_"); e = e.replace("?", "#"), r.isQuanX && $prefs.setValueForKey(t, e), (r.isLoon || r.isSurge) && $persistentStore.write(t, e), r.isNode && require("fs").writeFileSync(e + ".json", t, { flag: "w" }, e => console.log(e)) } } } getRequestBody() { var e = this.env, t = $request.path; let r = this.scriptName + "#" + t.replace("/", "_"); if (r = r.replace("?", "#"), e.isSurge || e.isLoon) return $persistentStore.read(r); if (e.isQuanX) return $prefs.valueForKey(r); if (e.isNode) { t = r + ".json", e = require("fs"); if (!e.existsSync(t)) return JSON.parse(e.readFileSync(t)) } } getResponseBody() { if ($response) return $response.body } parseCookies(e, t = !1) { let r = {}; return t ? e && e.split(";").forEach(function (e) { e = e.split("="); r[e.shift().trim()] = decodeURIComponent(e.join("=")) }) : e && e.split(";").forEach(function (e) { e = e.split("="); r[e.shift().trim()] = e.join("=") }), r } serializeCookies(e, t = !1) { var r = []; if (t) for (var n in e) { var o = e[n], n = n + "=" + encodeURIComponent(o); r.push(n) } else for (var i in e) { var s = e[i], i = i + "=" + s; r.push(i) } return r.join("; ") } parseSetCookies(e) { var t = e.split(/,\s*/).map(e => { var e = e.trim().split(/;\s*(?=[^=]+=[^;]*)/), t = e[0].split("=").map(e => e.trim()); const r = { name: t[0], value: t[1] }; return e.slice(1).forEach(e => { var [e, t] = e.split("=").map(e => e.trim()); r[e] = t || !0 }), r }), r = []; let n = 0; for (; n < t.length;) { var o, i = t[n]; r.push(i), i.Expires ? ((o = t[n + 1]) && (i.Expires = i.Expires + "," + o.name), n += 2) : n += 1 } return r } objToQueryStr(t, r) { let n = ""; for (const o in t) { let e = t[o]; null != e && "" !== e && ("object" == typeof e ? e = JSON.stringify(e) : r && (e = encodeURIComponent(e)), n += `${o}=${e}&`) } return n = n.substring(0, n.length - 1) } parseQueryStr(e) { var t = {}, r = (e = -1 < e.indexOf("?") ? e.split("?")[1] : e).split("&"); for (let e = 0; e < r.length; e++) { var n = r[e].split("="); t[n[0]] = n[1] } return t } deepClone(e, t) { for (var r in t = t || {}, e) "object" == typeof e[r] ? (t[r] = e[r].constructor === Array ? [] : {}, this.deepClone(e[r], t[r])) : t[r] = e[r]; return t } formatDate(e, t) { var r, n = { "M+": e.getMonth() + 1, "d+": e.getDate(), "H+": e.getHours(), "m+": e.getMinutes(), "s+": e.getSeconds(), "q+": Math.floor((e.getMonth() + 3) / 3), S: e.getMilliseconds() }; for (r in /(y+)/.test(t) && (t = t.replace(RegExp.$1, (e.getFullYear() + "").substr(4 - RegExp.$1.length))), n) new RegExp("(" + r + ")").test(t) && (t = t.replace(RegExp.$1, 1 == RegExp.$1.length ? n[r] : ("00" + n[r]).substr(("" + n[r]).length))); return t } parseDate(a, e) { let l = { y: 0, M: 1, d: 0, H: 0, h: 0, m: 0, s: 0, S: 0 }; (e = e || "yyyy-MM-dd").replace(/([^yMdHmsS]*?)(([yMdHmsS])\3*)([^yMdHmsS]*?)/g, function (e, t, r, n, o, i, s) { return a = a.replace(new RegExp(t + "(\\d{" + r.length + "})" + o), function (e, t) { return l[n] = parseInt(t), "" }), "" }), l.M--; e = new Date(l.y, l.M, l.d, l.H, l.m, l.s); return 0 !== l.S && e.setMilliseconds(l.S), e } getBaseDoneHeaders(e = {}) { return Object.assign({ "Access-Control-Allow-Origin": "*", "Access-Control-Allow-Methods": "POST,GET,OPTIONS,PUT,DELETE", "Access-Control-Allow-Headers": "Origin, X-Requested-With, Content-Type, Accept" }, e) } getHtmlDoneHeaders() { return this.getBaseDoneHeaders({ "Content-Type": "text/html;charset=UTF-8" }) } getJsonDoneHeaders() { return this.getBaseDoneHeaders({ "Content-Type": "text/json; charset=utf-8", Connection: "keep-alive" }) } doWxpusherSend(e) { var t = this.getJsonDoneHeaders(), t = (t.Host = "wxpusher.zjiecode.com", t["Content-Type"] = "application/json;charset=UTF-8", { url: "https://wxpusher.zjiecode.com/api/send/message", headers: t, body: JSON.stringify(e) }); return this.http.post(t) } fastWxpusherSend(e, t = "", r = "") { return this.doWxpusherSend({ appToken: "AT_7wDWqSoT8xpJCQqJtHpshKhw7kXc0XCW", content: e, summary: t, contentType: 1, topicIds: [], uids: ["UID_6P4B00X6Zv8U2oKC0I2R09emxtqq"], url: r, verifyPay: !1, verifyPayType: 0 }) } isEmpty(e) { return void 0 === e || null == e || "" == e || "null" == e || "undefined" == e || 0 === e.length } base64Encode(e) { var t, r, n, o = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"; let i, s, a; for (a = e.length, s = 0, i = ""; s < a;) { if (t = 255 & e.charCodeAt(s++), s == a) { i = (i += o.charAt(t >> 2)) + o.charAt((3 & t) << 4) + "=="; break } if (r = e.charCodeAt(s++), s == a) { i = (i = (i += o.charAt(t >> 2)) + o.charAt((3 & t) << 4 | (240 & r) >> 4)) + o.charAt((15 & r) << 2) + "="; break } n = e.charCodeAt(s++), i = (i = (i = (i += o.charAt(t >> 2)) + o.charAt((3 & t) << 4 | (240 & r) >> 4)) + o.charAt((15 & r) << 2 | (192 & n) >> 6)) + o.charAt(63 & n) } return i } base64Decode(e) { var t = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="; if (/([^\s]+[^0-9a-zA-Z\+\/\=]|[^0-9a-zA-Z\+\/\=]\s+)/.test(e)) throw new Error("Invalid base64 input"); var r, n, o, i, s, a, l = e.replace(/\s/g, ""); let u = "", c = 0; for (; c < l.length;)o = t.indexOf(l.charAt(c++)), r = (15 & (i = t.indexOf(l.charAt(c++)))) << 4 | (s = t.indexOf(l.charAt(c++))) >> 2, n = (3 & s) << 6 | (a = t.indexOf(l.charAt(c++))), u += String.fromCharCode(o << 2 | i >> 4), 64 !== s && (u += String.fromCharCode(r)), 64 !== a && (u += String.fromCharCode(n)); return u = this.utf8Decode(u) } utf8Decode(t) { let e = [], r = 0, n = 0, o = 0; for (t = t.replace(/\r\n/g, "\n"); r < t.length;) { n = 255 & t.charCodeAt(r), o = 0, o = n <= 191 ? (n &= 127, 1) : n <= 223 ? (n &= 31, 2) : n <= 239 ? (n &= 15, 3) : (n &= 7, 4); for (let e = 1; e < o; ++e)n = n << 6 | 63 & t.charCodeAt(e + r); 4 === o ? (n -= 65536, e.push(String.fromCharCode(55296 | n >> 10 & 1023)), e.push(String.fromCharCode(56320 | 1023 & n))) : e.push(String.fromCharCode(n)), r += o } return e.join("") } parseJwt(e) { try { var t = e.split("."), r = t[0].replace(/-/g, "+").replace(/_/g, "/"), n = this.base64Decode(r).replace(/\0/g, ""), o = JSON.parse(n), i = t[1].replace(/-/g, "+").replace(/_/g, "/"), s = this.base64Decode(i).replace(/\0/g, ""); return { header: o, payload: JSON.parse(s), signature: t[2] } } catch (e) { return this.log(e), null } } costTime() { var e = this.scriptName + "执行完毕！", t = (this._endTime = (new Date).getTime(), this._endTime - this._startTime); this.logger.info(e + `耗时【${t / 1e3}】秒`) } done = (e = {}) => { this.costTime(), "undefined" != typeof $done && $done(e) } }(e, t) } function MagicHttp(d, p) { var e; let g; d.isNode && (e = require("axios"), g = e.create()); class t { constructor(e = !0) { this.handlers = [], this.isRequest = e } use(e, t, r) { return "function" == typeof e && p.debug("Register fulfilled " + e.name), "function" == typeof t && p.debug("Register rejected " + t.name), this.handlers.push({ fulfilled: e, rejected: t, synchronous: !(!r || "boolean" != typeof r.synchronous) && r.synchronous, runWhen: r ? r.runWhen : null }), this.handlers.length - 1 } eject(e) { this.handlers[e] && (this.handlers[e] = null) } forEach(t) { this.handlers.forEach(e => { null !== e && t(e) }) } } function f(e) { let r = { ...e }; return r.params && !d.isNode && (e = Object.keys(r.params).map(e => { var t = encodeURIComponent(e); return r.url = r.url.replace(new RegExp(e + "=[^&]*", "ig"), ""), r.url = r.url.replace(new RegExp(t + "=[^&]*", "ig"), ""), t + "=" + encodeURIComponent(r.params[e]) }).join("&"), r.url.indexOf("?") < 0 && (r.url += "?"), /(&|\?)$/g.test(r.url) || (r.url += "&"), r.url += e, delete r.params, p.debug("Params to QueryString: " + r.url)), r } const h = (e, t = null) => { if (e) { t = { ...e, config: e.config || t, status: e.statusCode || e.status, body: e.body || e.data, headers: e.headers || e.header }; if ("string" == typeof t.body) try { t.body = JSON.parse(t.body) } catch { } return delete t.data, t } return e }; const y = (e, t = null) => { if (e && 400 <= e.status) return p.debug("Raise exception when status code is " + e.status), { name: "RequestException", message: "Request failed with status code " + e.status, config: t || e.config, response: e } }, m = { request: new t, response: new t(!1) }; let v = [], b = [], S = !0; function N(e) { return e = f(e), p.debug(`HTTP ${e.method.toUpperCase()}:` + "\n" + JSON.stringify(e)), e } function E(t) { try { t = t && h(t), p.sniffer(`HTTP ${t.config.method.toUpperCase()}:` + "\n" + JSON.stringify(t.config) + "\nSTATUS CODE:\n" + t.status + "\nRESPONSE:\n" + ("object" == typeof t.body ? JSON.stringify(t.body) : t.body)); var e = y(t); return e ? Promise.reject(e) : t } catch (e) { return p.error(e), t } } const r = (e, r) => { let n; r = ((e, t) => { let r = "object" == typeof t ? { headers: {}, ...t } : { url: t, headers: {} }; return r.method || (r.method = e), !0 === (r = f(r)).rewrite && (d.isSurge ? (r.headers["X-Surge-Skip-Scripting"] = !1, delete r.rewrite) : d.isQuanX && (r.hints = !1, delete r.rewrite)), d.isSurgeLike ? (t = r.headers["content-type"] || r.headers["Content-Type"], "GET" !== r.method && t && 0 <= t.indexOf("application/json") && r.body instanceof Array && (r.body = JSON.stringify(r.body), p.debug("Convert Array object to String: " + r.body))) : d.isQuanX ? (r.hasOwnProperty("body") && "string" != typeof r.body && (r.body = JSON.stringify(r.body)), r.method = e) : d.isNode && ("POST" === e || "PUT" === e || "PATCH" === e || "DELETE" === e ? r.data = r.data || r.body : "GET" === e && (r.params = r.params || r.body), delete r.body), r })(e.toUpperCase(), r), n = d.isNode ? g : d.isSurgeLike ? i => new Promise((n, o) => { $httpClient[e.toLowerCase()](i, (e, t, r) => { e ? (e = { name: e.name || e, message: e.message || e, stack: e.stack || e, config: i, response: h(t) }, o(e)) : (t.config = i, t.body = r, n(t)) }) }) : n => new Promise((r, t) => { $task.fetch(n).then(e => { e = h(e, n); var t = y(e, n); if (t) return Promise.reject(t); r(e) }).catch(e => { e = { name: e.message || e.error, message: e.message || e.error, stack: e.error, config: n, response: e.response ? h(e.response) : null }; t(e) }) }); let o; var t = r; try { v = [], b = [], m.request.forEach(e => { "function" == typeof e.runWhen && !1 === e.runWhen(t) || (S = S && e.synchronous, v.unshift(e.fulfilled, e.rejected)) }), m.response.forEach(e => { b.push(e.fulfilled, e.rejected) }) } catch (e) { p.error(`Failed to register interceptors: ${e}.`) } var i = [N, void 0], s = [E, void 0]; if (S) { for (p.debug("Interceptors are executed in synchronous mode"), Array.prototype.unshift.apply(v, i), v = v.concat([N, void 0]); v.length;) { var a = v.shift(), l = v.shift(); try { "function" == typeof a && p.debug("Executing request fulfilled " + a.name), r = a(r) } catch (e) { "function" == typeof l && p.debug("Executing request rejected " + l.name), l(e); break } } try { o = (!d.isNode && r.timeout ? c : n)(r) } catch (e) { return Promise.reject(e) } for (Array.prototype.unshift.apply(b, s); b.length;)o = o.then(b.shift(), b.shift()); return o } { p.debug("Interceptors are executed in asynchronous mode"); let t = [n, void 0]; for (Array.prototype.unshift.apply(t, i), Array.prototype.unshift.apply(t, v), t = (t = t.concat(s)).concat(b), o = Promise.resolve(r); t.length;)try { let e = t.shift(); var u = t.shift(); "function" == typeof (e = !d.isNode && r.timeout && e === n ? c : e) && p.debug("Executing request fulfilled " + e.name), "function" == typeof u && p.debug("Executing request rejected " + u.name), o = o.then(e, u) } catch (e) { p.error("request exception: " + e) } return o } function c(r) { try { var e = new Promise((e, t) => { setTimeout(() => { var e = { message: `timeout of ${r.timeout}ms exceeded.`, config: r }; t(e) }, r.timeout) }); return Promise.race([n(r), e]) } catch (e) { p.error(`Request Timeout exception: ${e}.`) } } }; return { request: r, interceptors: m, convertHeadersToLowerCase: r => Object.keys(r).reduce((e, t) => (e[t.toLowerCase()] = r[t], e), {}), convertHeadersToCamelCase: r => Object.keys(r).reduce((e, t) => { return e[t.split("-").map(e => e[0].toUpperCase() + e.slice(1)).join("-")] = r[t], e }, {}), modifyResponse: h, get: e => r("GET", e), post: e => r("POST", e), put: e => r("PUT", e), patch: e => r("PATCH", e), delete: e => r("DELETE", e), head: e => r("HEAD", e), options: e => r("OPTIONS", e) } } function MagicData(d, p) { let g = { fs: void 0, data: {} }; if (d.isNode) { g.fs = require("fs"); try { g.fs.accessSync("./magic.json", g.fs.constants.R_OK | g.fs.constants.W_OK) } catch (e) { g.fs.writeFileSync("./magic.json", "{}", { encoding: "utf8" }) } g.data = require("./magic.json") } const s = (e, t) => "object" != typeof t && e === t, a = e => "true" === e || "false" !== e && (void 0 === e ? null : e), l = (e, t, r, n) => { if (r) try { e = !0 === (e = "string" == typeof e ? JSON.parse(e) : e).magic_session ? e[r] : null } catch { e = null } if ("string" == typeof e && "null" !== e) try { e = JSON.parse(e) } catch { } return null == (e = !1 === n && e && !0 === e.magic_session ? null : e) && null != t && (e = t), e = a(e) }, f = t => { if ("string" != typeof t) return t instanceof Array || null == t || t != t || "boolean" == typeof t ? {} : t; { let e = {}; try { var r = typeof (e = JSON.parse(t)); ("object" != r || e instanceof Array || "bool" == r || null === e) && (e = {}) } catch { } return e } }, u = (e, t = null, r = "", n = !1, o = null) => { let i = ""; return i = o || d.isNode ? ((e, t = null, r = "", n = !1, o = null) => { o = o || g.data; return val = o && void 0 !== o[e] && null !== o[e] ? o[e] : r ? {} : null, val = l(val, t, r, n) })(e, t, r, n, o) : (d.isSurgeLike ? i = $persistentStore.read(e) : d.isQuanX && (i = $prefs.valueForKey(e)), l(i, t, r, n)), p.debug(`READ DATA [${e}]${r ? `[${r}]` : ""} <${typeof i}>` + "\n" + JSON.stringify(i)), i }, c = (e, t, r = "", n = null) => { if (void 0 === t || t != t) return !1; d.isNode || "boolean" != typeof t && "number" != typeof t || (t = String(t)); let o = ""; var i, s, a, l, u, c; if (n || d.isNode ? o = ([i, s, a = "", l = null] = [e, t, r, n], c = l || g.data, c = f(c), a ? ((u = f(c[i])).magic_session = !0, u[a] = s, c[i] = u) : c[i] = s, null !== l && (l = c), c) : r ? (d.isSurgeLike ? o = $persistentStore.read(e) ? $persistentStore.read(e) : o : d.isQuanX && (o = $prefs.valueForKey(e) ? $prefs.valueForKey(e) : o), (o = f(o)).magic_session = !0, o[r] = t) : o = t, o && "object" == typeof o && (o = JSON.stringify(o, null, 4)), p.debug(`WRITE DATA [${e}]${r ? `[${r}]` : ""} <${typeof t}>` + "\n" + JSON.stringify(t)), !n) { if (d.isSurgeLike) return $persistentStore.write(o, e); if (d.isQuanX) return $prefs.setValueForKey(o, e); if (d.isNode) try { g.fs.writeFileSync("./magic.json", o) } catch (e) { return p.error(e), !1 } } return !0 }; return { read: u, write: c, del: (e, t = "", r = null) => { let n = {}; if (r || d.isNode) n = (o = e, i = t, s = r || g.data, s = f(s), i ? (delete (obj = f(s[o]))[i], s[o] = obj) : delete s[o], s), r ? r = n : g.fs.writeFileSync("./magic.json", JSON.stringify(n, null, 4)); else if (t) { d.isSurgeLike ? n = $persistentStore.read(e) : d.isQuanX && (n = $prefs.valueForKey(e)), delete (n = f(n))[t]; i = JSON.stringify(n, null, 4); c(e, i) } else { if (d.isStorm) return $persistentStore.remove(e); if (d.isSurgeLike) return $persistentStore.write(null, e); if (d.isQuanX) return $prefs.removeValueForKey(e) } var o, i, s; p.debug(`DELETE KEY [${e}]` + (t ? `[${t}]` : "")) }, update: (e, t, r, n = s, o = null) => { var i; return t = a(t), !0 !== n(u(e, null, r, !1, o), t) && (i = c(e, t, r, o), e = u(e, null, r, !1, o), n === s && "object" == typeof e ? i : n(t, e)) }, allSessions: (e, t = null) => { let r = {}; t = u(e, null, null, !0, t); return !0 === (t = f(t)).magic_session && delete (r = { ...t }).magic_session, p.debug(`READ ALL SESSIONS [${e}] <${typeof r}>` + "\n" + JSON.stringify(r, null, 4)), r }, allSessionNames: (e, t = null) => { let r = []; t = u(e, null, null, !0, t), t = f(t); return r = !0 !== t.magic_session ? [] : Object.keys(t).filter(e => "magic_session" !== e), p.debug(`READ ALL SESSIONS [${e}] <${typeof r}>` + "\n" + JSON.stringify(r, null, 4)), r }, defaultValueComparator: s, convertToObject: f } } function MagicNotification(i, o, s, a) { let l = null, u = null, c = []; function d(e = i, t = "", r = "", n = "") { n = (t => { try { let e = {}; var r; return "string" == typeof t ? 0 < t.length && (o.isLoon ? e = { openUrl: t } : o.isQuanX ? e = { "open-url": t } : o.isSurge && (e = { url: t })) : "object" == typeof t && (o.isLoon ? (e.openUrl = t["open-url"] || "", e.mediaUrl = t["media-url"] || "") : o.isQuanX ? e = t["open-url"] || t["media-url"] ? t : {} : o.isSurge && (r = t["open-url"] || t.openUrl, e = r ? { url: r } : {})), e } catch (e) { s.error("通知选项转换失败" + e) } return t })(n), 1 === arguments.length && (e = i, t = "", r = arguments[0]), s.notify("\ntitle:" + e + "\nsubTitle:" + t + "\nbody:" + r + "\noptions:" + ("object" == typeof n ? JSON.stringify(n) : n)), o.isSurge ? $notification.post(e, t, r, n) : o.isLoon ? n ? $notification.post(e, t, r, n) : $notification.post(e, t, r) : o.isQuanX && $notify(e, t, r, n), l && u && p(e, t, r) } function p(e = i, t = "", r = "", n) { if (void 0 === a || void 0 === a.post) throw "Bark notification needs to import MagicHttp module."; e = { url: l, headers: { "content-type": "application/json; charset=utf-8" }, body: { title: e, body: t ? t + "\n" + r : r, device_key: u } }; a.post(e).catch(e => { s.error("Bark notify error: " + e) }) } return { post: d, debug: function (e = i, t = "", r = "", n = "") { "DEBUG" === s.getLevel() && (1 === arguments.length && (e = i, t = "", r = arguments[0]), this.post(e, t, r, n)) }, bark: p, setBark: e => { try { var t = e.replace(/\/+$/g, ""); l = /^https?:\/\/([^/]*)/.exec(t)[0] + "/push", u = /\/([^\/]+)\/?$/.exec(t)[1] } catch (e) { s.error(`Bark url error: ${e}.`) } }, appendNotifyInfo: function (e, t) { 1 == t ? c = e : c.push(e) }, prependNotifyInfo: function (e) { c.splice(0, 0, e) }, msg: function (e, t, r, n) { var o = {}; r && (o["open-url"] = r), n && (o["media-url"] = n), (t = t && 0 != t.length ? t : Array.isArray(c) ? c.join("\n") : c) && 0 < t.length && d(i, "", t, o) } } } function MagicUtils(n, u) { const e = (e, t = "yyyy-MM-dd hh:mm:ss") => { var r, n = { "M+": e.getMonth() + 1, "d+": e.getDate(), "h+": e.getHours(), "m+": e.getMinutes(), "s+": e.getSeconds(), "q+": Math.floor((e.getMonth() + 3) / 3), S: e.getMilliseconds() }; for (r in /(y+)/.test(t) && (t = t.replace(RegExp.$1, (e.getFullYear() + "").substr(4 - RegExp.$1.length))), n) new RegExp("(" + r + ")").test(t) && (t = t.replace(RegExp.$1, 1 === RegExp.$1.length ? n[r] : ("00" + n[r]).substr(("" + n[r]).length))); return t }; return { retry: (i, s = 5, a = 0, l = null) => (...e) => new Promise((r, n) => { function o(...t) { Promise.resolve().then(() => i.apply(this, t)).then(e => { "function" == typeof l ? Promise.resolve().then(() => l(e)).then(() => { r(e) }).catch(e => { 1 <= s ? 0 < a ? setTimeout(() => o.apply(this, t), a) : o.apply(this, t) : n(e), s-- }) : r(e) }).catch(e => { u.error(e), 1 <= s && 0 < a ? setTimeout(() => o.apply(this, t), a) : 1 <= s ? o.apply(this, t) : n(e), s-- }) } o.apply(this, e) }), formatTime: e, now: () => e(new Date, "yyyy-MM-dd hh:mm:ss"), today: () => e(new Date, "yyyy-MM-dd"), sleep: t => new Promise(e => setTimeout(e, t)), assert: (e, t = null) => { var r; n.isNode ? (r = require("assert"), t ? r(e, t) : r(e)) : !0 !== e && u.error("AssertionError: " + (t || "The expression evaluated to a falsy value.")) } } } function MagicQingLong(e, a, o) { let i = "", s = "", l = "", u = "", c = "", t = ""; const d = "magic.json", p = MagicHttp(e, o); async function r() { return l = l || a.read("magic_qlclient"), u = u || a.read("magic_qlsecrt"), s = s || a.read("magic_qlname"), c = c || a.read("magic_qlpwd"), i && l && u ? (o.info("Get token from QingLong Panel"), await p.get({ url: "/open/auth/token", headers: { "content-type": "application/json" }, params: { client_id: l, client_secret: u } }).then(e => { if (!(0 < Object.keys(e.body).length && e.body.data && e.body.data.token)) throw new Error("Get QingLong Panel token failed."); o.info("Successfully logged in to QingLong Panel"), t = e.body.data.token, a.write("magic_qltoken", t) }).catch(e => { o.error("Error logging in to QingLong Panel.\n" + (e.message || e)) })) : i && s && c && await p.post({ url: "/api/user/login", headers: { "content-type": "application/json" }, body: { username: s, password: c } }).then(e => { o.info("Successfully logged in to QingLong Panel"), t = e.body.data.token, a.write("magic_qltoken", t) }).catch(e => { o.error("Error logging in to QingLong Panel.\n" + (e.message || e)) }), t } async function g(e) { let t = []; return await p.post({ url: "/api/envs", headers: { "content-type": "application/json" }, body: e }).then(e => { 200 === e.body.code ? e.body.data.forEach(e => { o.debug(`QINGLONG ADD ENV ${e.name} <${typeof e.value}> (${e.id})` + "\n" + JSON.stringify(e)), t.push(e.id) }) : o.error("Error adding environments variable from QingLong Panel.\n" + JSON.stringify(e)) }).catch(e => { o.error("Error adding environments variable from QingLong Panel.\n" + (e.message || e)) }), t } async function n(n = null, e = "", t) { let o = []; return await p.get({ url: "/api/envs", headers: { "content-type": "application/json" }, params: { searchValue: e } }).then(e => { if (200 !== e.body.code) throw new Error("Error reading environment variable from QingLong Panel.\n" + JSON.stringify(e)); e = e.body.data; if (n) { var t = []; for (const r of e) r.name === n && o.push(r); o = t } o = e }).catch(e => { throw new Error("Error reading environments variable from QingLong Panel.\n" + (e.message || e)) }), o } async function f(e, t = "") { let r = ""; return await p.get({ url: "/api/scripts/" + e, params: { path: t } }).then(e => { if (200 !== e.body.code) throw new Error("Error reading data from QingLong Panel.\n" + JSON.stringify(e)); r = e.body.data }).catch(e => { throw new Error("Error reading data from QingLong Panel.\n" + (e.message || e)) }), r } async function h(e, t = "", r = "") { let n = !1; return await p.put({ url: "/api/scripts", headers: { "content-type": "application/json" }, body: { filename: e, path: t, content: r } }).then(e => { 200 === e.body.code ? n = !0 : o.error("Error reading data from QingLong Panel.\n" + JSON.stringify(e)) }).catch(e => { o.error("Error reading data from QingLong Panel.\n" + (e.message || e)) }), n } return p.interceptors.request.use(function (e) { return i = i || a.read("magic_qlurl"), e.url.indexOf(i) < 0 && (e.url = "" + i + e.url), { ...e, timeout: 3e3 } }, void 0), p.interceptors.request.use(function (e) { return (l = l || a.read("magic_qlclient")) && (e.url = e.url.replace("/api/", "/open/")), e }, void 0, { runWhen: e => e.url.indexOf("api/user/login") < 0 && e.url.indexOf("open/auth/token") < 0 }), p.interceptors.request.use(async function (e) { return (t = t || a.read("magic_qltoken", "")) || await r(), e.headers.authorization = "Bearer " + t, e }, void 0, { runWhen: e => e.url.indexOf("api/user/login") < 0 && e.url.indexOf("open/auth/token") < 0 }), p.interceptors.request.use(function (e) { return e.params = { ...e.params, t: Date.now() }, e }, void 0, { runWhen: e => e.url.indexOf("open/auth/token") < 0 }), p.interceptors.request.use(function (e) { return i = i || a.read("magic_qlurl"), t = t || a.read("magic_qltoken"), o.debug("QingLong url: " + i + "\nQingLong token: " + t), e }, void 0), p.interceptors.response.use(void 0, async function (e) { try { var t = e.message || e.error || JSON.stringify(e); return (0 <= t.indexOf("NSURLErrorDomain") && 0 <= t.indexOf("-1012") || e.response && 401 === e.response.status) && e.config && !0 !== e.config.refreshToken ? (o.warning("QingLong Panel token has expired"), o.info("Refreshing the QingLong Panel token"), await r(), e.config.refreshToken = !0, o.info("Call the previous method again"), await p.request(e.config.method, e.config)) : Promise.reject(e) } catch (e) { return Promise.reject(e) } }), { url: i || a.read("magic_qlurl"), init: (e, t, r, n, o) => { i = e, l = t, u = r, s = n, c = o }, getToken: r, setEnv: async function (t, r, n = null) { if (i = i || a.read("magic_qlurl"), null === n) { var e = await g([{ name: t, value: r }]); if (e && 1 === e.length) return e[0] } else await p.put({ url: "/api/envs", headers: { "content-type": "application/json" }, body: { name: t, value: r, id: n } }).then(e => { if (200 === e.body.code) return o.debug(`QINGLONG UPDATE ENV ${t} <${typeof r}> (${n})` + "\n" + JSON.stringify(r)), !0; o.error("Error adding environment variable from QingLong Panel.\n" + JSON.stringify(e)) }).catch(e => (o.error("Error adding environment variable from QingLong Panel.\n" + (e.message || e)), !1)) }, setEnvs: g, getEnv: async function (e) { let t = null; for (const r of await n()) if (r.id === e) { t = r; break } return t }, getEnvs: n, delEnvs: async function (t) { return p.delete({ url: "/api/envs", headers: { accept: "application/json", "accept-language": "zh-CN,zh;q=0.9,en;q=0.8,en-GB;q=0.7,en-US;q=0.6", connection: "keep-alive", "content-type": "application/json;charset=UTF-8", "user-agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/102.0.5005.63 Safari/537.36 Edg/102.0.1245.30" }, body: t }).then(e => 200 === e.body.code ? (o.debug("QINGLONG DELETE ENV IDS: " + t), !0) : (o.error("Error deleting environments variable from QingLong Panel.\n" + JSON.stringify(e)), !1)).catch(e => { o.error("Error deleting environments variable from QingLong Panel.\n" + (e.message || e)) }) }, disableEnvs: async function (t) { let r = !1; return await p.put({ url: "/api/envs/disable", headers: { accept: "application/json", "accept-Language": "zh-CN,zh;q=0.9,en;q=0.8,en-GB;q=0.7,en-US;q=0.6", connection: "keep-alive", "content-type": "application/json;charset=UTF-8", "user-agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/102.0.5005.63 Safari/537.36 Edg/102.0.1245.30" }, body: t }).then(e => { 200 === e.body.code ? (o.debug("QINGLONG DISABLED ENV IDS: " + t), r = !0) : o.error("Error disabling environments variable from QingLong Panel.\n" + JSON.stringify(e)) }).catch(e => { o.error("Error disabling environments variable from QingLong Panel.\n" + (e.message || e)) }), r }, enableEnvs: async function (t) { let r = !1; return await p.put({ url: "/api/envs/enable", headers: { accept: "application/json", "accept-language": "zh-CN,zh;q=0.9,en;q=0.8,en-GB;q=0.7,en-US;q=0.6", connection: "keep-alive", "content-type": "application/json;charset=UTF-8", "user-agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/102.0.5005.63 Safari/537.36 Edg/102.0.1245.30" }, body: t }).then(e => { 200 === e.body.code ? (o.debug("QINGLONG ENABLED ENV IDS: " + t), r = !0) : o.error("Error enabling environments variable from Qilong panel.\n" + JSON.stringify(e)) }).catch(e => { o.error("Error enabling environments variable from Qilong panel.\n" + (e.message || e)) }), r }, addScript: async function (e, t = "", r = "") { let n = !1; return await p.post({ url: "/api/scripts", headers: { "content-type": "application/json" }, body: { filename: e, path: t, content: r } }).then(e => { 200 === e.body.code ? n = !0 : o.error("Error reading data from QingLong Panel.\n" + JSON.stringify(e)) }).catch(e => { o.error("Error reading data from QingLong Panel.\n" + (e.message || e)) }), n }, getScript: f, editScript: h, delScript: async function (e, t = "") { let r = !1; return await p.delete({ url: "/api/scripts", headers: { "content-type": "application/json" }, body: { filename: e, path: t } }).then(e => { 200 === e.body.code ? r = !0 : o.error("Error reading data from QingLong Panel.\n" + JSON.stringify(e)) }).catch(e => { o.error("Error reading data from QingLong Panel.\n" + (e.message || e)) }), r }, write: async function (e, t, r = "") { var n = await f(d, ""), o = a.convertToObject(n), e = a.write(e, t, r, o), n = JSON.stringify(o, null, 4); return await h(d, "", n) && e }, read: async function (e, t, r = "", n = !1) { var o = await f(d, ""), o = a.convertToObject(o); return a.read(e, t, r, n, o) }, del: async function (e, t = "") { var r = await f(d, ""), n = a.convertToObject(r), e = a.del(e, t, n), r = JSON.stringify(n, null, 4), t = await h(d, "", r); return e && t }, update: async function (e, t, r, n = a.defaultValueComparator) { var o = await f(d, ""), i = a.convertToObject(o), e = a.update(e, t, r, n, i); let s = !1; return !0 === e && (o = JSON.stringify(i, null, 4), s = await h(d, "", o)), e && s }, batchWrite: async function (...e) { var t, r = await f(d, ""), n = a.convertToObject(r); for (t of e) a.write(t[0], t[1], void 0 !== t[2] ? t[2] : "", n); return r = JSON.stringify(n, null, 4), h(d, "", r) }, batchRead: async function (...e) { var t, r = await f(d, ""), n = a.convertToObject(r), o = []; for (t of e) { var i = a.read(t[0], t[1], void 0 !== t[2] ? t[2] : "", "boolean" == typeof t[3] && t[3], n); o.push(i) } return o }, batchUpdate: async function (...e) { var t, r = await f(d, ""), n = a.convertToObject(r); for (t of e) a.update(t[0], t[1], void 0 !== t[2] ? t[2] : "", void 0 !== t[3] ? t.comparator : a.defaultValueComparator, n); return r = JSON.stringify(n, null, 4), h(d, "", r) }, batchDel: async function (...e) { var t, r = await f(d, ""), n = a.convertToObject(r); for (t of e) a.del(t[0], void 0 !== t[1] ? t[1] : "", n); return r = JSON.stringify(n, null, 4), h(d, "", r) }, allSessions: async function (e) { var t = await f(d, ""), t = a.convertToObject(t); return a.allSessions(e, t) }, allSessionNames: async function (e) { var t = await f(d, ""), t = a.convertToObject(t); return a.allSessionNames(e, t) } } }
//---SyncByPyScript---MagicJS3-end